// DirectDraw.cpp: implementation of the CDirectDraw class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Direct.h"
#include "DirectDraw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDirectDraw::CDirectDraw()
{
lpDD=NULL;
PrimarySurf=NULL;
SecondarySurf=NULL;
memset(&strsurf,0,sizeof(DDSURFACEDESC));
strsurf.dwSize = sizeof(DDSURFACEDESC);

}

CDirectDraw::~CDirectDraw()
{
lpDD->RestoreDisplayMode();
lpDD->SetCooperativeLevel(0,DDSCL_NORMAL );  
if (SecondarySurf!=NULL) SecondarySurf->Release(); 
if (PrimarySurf!=NULL) PrimarySurf->Release();	
if (lpDD!=NULL) lpDD->Release();
}

BOOL CDirectDraw::InitDirectDraw()
{
rezult = DirectDrawCreate(NULL, &lpDD, NULL );
if( rezult != DD_OK )  return FALSE;
return TRUE;
}

BOOL CDirectDraw::GetFullScreenCooperativeLevel()
{
if (lpDD->SetCooperativeLevel(AfxGetMainWnd()->GetSafeHwnd(),DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN )!=DD_OK) return FALSE;
return TRUE;
}

BOOL CDirectDraw::SetMode640_480_8()
{
if (lpDD->SetDisplayMode(640,480,8) !=DD_OK) return FALSE;
return TRUE;
}

BOOL CDirectDraw::CreatePrimarySurf()
{
strsurf.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT; 
strsurf.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX; 
strsurf.dwBackBufferCount = 1;
if (lpDD->CreateSurface(&strsurf,&PrimarySurf,NULL) !=DD_OK) return FALSE;
return TRUE;
}

BOOL CDirectDraw::GetSecondarySurf()
{
strsurfsec.dwCaps = DDSCAPS_BACKBUFFER;
if (PrimarySurf->GetAttachedSurface(&strsurfsec,&SecondarySurf)!= DD_OK) return FALSE;
return TRUE;
}

BOOL CDirectDraw::ClearSurfSecond()
{
memset(&DdsdSecond,0,sizeof(DDSURFACEDESC));
DdsdSecond.dwSize = sizeof(DDSURFACEDESC);
if (SecondarySurf->Lock(NULL,&DdsdSecond,DDLOCK_WAIT | DDLOCK_SURFACEMEMORYPTR,NULL)!=DD_OK) return FALSE;

    //      ,  
    char* buf = (char*)DdsdSecond.lpSurface;
	memset(buf,0,(DdsdSecond.dwHeight * DdsdSecond.dwHeight)); 
    //
    
if (SecondarySurf->Unlock(NULL)!=DD_OK) return FALSE; 
return TRUE;
}

BOOL CDirectDraw::Flips()
{
if (PrimarySurf->Flip(NULL,DDFLIP_WAIT) !=DD_OK) return FALSE; 
return TRUE;
}
